<script lang="ts">
  import { createEventDispatcher } from "svelte";
  import Card from "./Card.svelte";
  import Clickable from "./Clickable.svelte";

  const dispatch = createEventDispatcher();

  export let cards: CardId[];
  export let clickable: boolean = false;
  export let facedown: boolean = false;

  $: visibleCards = cards.slice(-6);
</script>

<div class="relative">
  {#each visibleCards as card, idx (card)}
    <div class="card" style:--card-offset="{-idx * 2}px">
      <Card {card} {facedown} />
    </div>
  {/each}
  {#if clickable}
    <div
      class="draw-card"
      style:--button-offset="{-(visibleCards.length - 1) * 2}px"
    >
      <Clickable on:click={() => dispatch("draw_card")} />
    </div>
  {/if}
</div>

<style>
  .card:not(:first-child) {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%)
      translate(var(--card-offset), var(--card-offset));
  }

  .draw-card {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%)
      translate(var(--button-offset), var(--button-offset));
  }
</style>
